--local context = UI.CreateContext("unncessary")

function lookatitem()
	for k, v in pairs(Inspect.Item.Detail(Utility.Item.Slot.Inventory(1,1))) do
		print((tostring(k)) .. " - " .. (tostring(v)))
	end
end


function printlist()
	printme = genlist()
	for k, v in pairs(printme) do
		for a, b in pairs(printme[k]) do
		print(k .. " - " .. a .. " - " .. b["name"]) end
	end
end

--find bags.. pesky people not having all bag slots used
function findnextbag(currentbag)
	if((currentbag + 1) < 6) then
		if(Inspect.Item.List(Utility.Item.Slot.Inventory("bag",(currentbag + 1)))) then
			return (currentbag + 1)
		else
			return findnextbag(currentbag + 1)
		end
	else return 6
	end
end

--generates an in order list of items in your inventory
function genlist()
--	print("--GENERATING NEW LIST--")
	bagnumber = findnextbag(0)
	slotnumber = 1
	thelist = {}
	while bagnumber < 6 do
--		print(Inspect.Item.List(Utility.Item.Slot.Inventory(bagnumber,slotnumber)))
		if(Inspect.Item.List(Utility.Item.Slot.Inventory(bagnumber,slotnumber))) then
			table.insert(thelist, {[(Utility.Item.Slot.Inventory(bagnumber,slotnumber))] = (Inspect.Item.Detail(Utility.Item.Slot.Inventory(bagnumber,slotnumber)))})
		end
		slotnumber = slotnumber + 1
		if(slotnumber>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumber)))["slots"]) then
			bagnumber = findnextbag(bagnumber)
			slotnumber = 1
		end
	end
	return thelist
end

--Place things in front of inventory (first bag, first slot): Trash (grey) -> Unbound Green armor/weapons -> Unbound Blue armor/weapons -> Quest Items -> crafting stuff (will skip to bag #2 if haven't gotten there yet)
function sorttrash()
	bagnumberfront = findnextbag(0)
	slotnumberfront = 1
	cashvaluetrash = 0
	cashvaluegreen = 0
	cashvalueblue = 0
	
	--Put trash loot in the first (front) slots
--	items = Inspect.Item.Detail(Utility.Item.Slot.Inventory())
	itemsfortrash = genlist()
	for a, b in pairs(itemsfortrash) do
		for k, v in pairs(itemsfortrash[a]) do
			if((v["rarity"]) and string.find(v["rarity"], "trash")) then
				-- save on moves for the command throttle if trash is already where it should be
				if(not(k == Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))) then
					Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
--					print("moving " .. v["name"] .. " from: " .. k .. " to: " .. Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
--					print(Inspect.Item.Detail(Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))["name"] .. " is in slot " .. Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
				end
				if(v["stack"]) then stack = v["stack"] else stack = 1 end
				cashvaluetrash = cashvaluetrash + (v["sell"] * stack)
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	
	--Next, scrolls.. pesky scrolls..
	items = genlist()
	for a, b in pairs(items) do
		for k, v in pairs(items[a]) do
			if((v["category"]) and string.find(v["category"], "consumable scroll")) then
	--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberfront .. " slot#: " .. slotnumberfront)
				Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
				if(v["stack"]) then stack = v["stack"] else stack = 1 end
				if(v["sell"]) then cashvaluetrash = cashvaluetrash + (v["sell"] * stack) end
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	
	--Next, move up uncommon (green) armor/weapons (usually additional trash) that aren't bound
	items = genlist()
	for a, b in pairs(items) do
		for k, v in pairs(items[a]) do
			if((v["rarity"]) and (string.find(v["rarity"], "uncommon")) and ((string.find(v["category"], "armor")) or (string.find(v["category"], "weapon")) or (string.find(v["category"], "planar"))) and (not((v["bound"] == true)))) then
	--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberfront .. " slot#: " .. slotnumberfront)
				Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
				if(v["sell"]) then cashvaluegreen = cashvaluegreen + v["sell"] end
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	
	--Next, move up rare (blue) armor/weapons that aren't bound
	items = genlist()
	for a, b in pairs(items) do
		for k, v in pairs(items[a]) do
			if((v["rarity"]) and (string.find(v["rarity"], "rare")) and ((string.find(v["category"], "armor")) or (string.find(v["category"], "weapon")) or (string.find(v["category"], "planar"))) and (not((v["bound"] == true)))) then
	--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberfront .. " slot#: " .. slotnumberfront)
				Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
				if(v["sell"]) then cashvalueblue = cashvalueblue + v["sell"] end
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	
	--move artifacts up
	items = genlist()
	for a, b in pairs(items) do
		for k, v in pairs(items[a]) do
			if( (v["category"]) and string.find(v["category"], "collectible") ) then
	--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberfront .. " slot#: " .. slotnumberfront)
				Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	
	--Next, move up all quest items floating around in the inventory
	items = genlist()
	for a, b in pairs(items) do
		for k, v in pairs(items[a]) do
			if((v["category"]) and string.find(v["category"], "quest")) then
	--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberfront .. " slot#: " .. slotnumberfront)
				Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	
	--Now, put all crafting stuff either in the next available slots, or jump to bag#2 if we haven't filled bag#1 yet, to make things look tidy
	itemsforcraft = genlist()
--	if (bagnumberfront<2) then 
--		bagnumberfront = findnextbag(1)
--		slotnumberfront = 1
--	end
	for a, b in pairs(itemsforcraft) do
		for k, v in pairs(itemsforcraft[a]) do
			if((v["category"]) and string.find(v["category"], "crafting")) then
				if(not(k == Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))) then
					Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
--					print("moving " .. v["name"] .. " from: " .. k .. " to: " .. Utility.Item.Slot.Inventory(bagnumberfront,slotnumberfront))
					-- save on moves for the command throttle if trash is already where it should be
				end
				slotnumberfront = slotnumberfront + 1
				if(slotnumberfront>(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberfront)))["slots"]) then
					bagnumberfront = findnextbag(bagnumberfront)
					slotnumberfront = 1
				end
			end
		end
	end
	cashvalue = cashvaluetrash + cashvaluegreen + cashvalueblue
	
--	print(math.floor(cashvaluetrash / 100) .. "g" .. (cashvaluetrash % 100) .. "s in trash\n" .. cashvaluegreen .. " in greens\n" .. cashvalueblue .. " in blues\n Total: " .. cashvalue)
	if (cashvalue > 9999) then
		print(math.floor(cashvalue / 10000) .. "p " .. ((math.floor(cashvalue / 100)) % 100) .. "g " .. (cashvalue % 100) .. "s in loot")
	elseif (cashvalue > 99) then
		print(math.floor(cashvalue / 100) .. "g " .. (cashvalue % 100) .. "s in loot")
	elseif (cashvalue > 0) then
		print(cashvalue .. "s in loot")
	end
end

--Place things in back of inventory (last bag, last slot first): bound armor -> Potions -> Food/Drink
function sortgear()
	bagnumberback = 5
	slotnumberback = (Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberback)))["slots"]
	
	--Loads things to the last slots of the inventory (last bag, last slot first) starting with bound armor
	items = Inspect.Item.Detail(Utility.Item.Slot.Inventory())
	for k, v in pairs(items) do
		if((v["bound"] == true) and (string.find(v["category"], "armor"))) then
--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberback .. " slot#: " .. slotnumberback)
			if(not(k == Utility.Item.Slot.Inventory(bagnumberback,slotnumberback))) then
			Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberback,slotnumberback)) end
			slotnumberback = slotnumberback - 1
			if(slotnumberback<1) then
				bagnumberback = bagnumberback - 1
				slotnumberback = (Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberback)))["slots"]
			end
		end
	end
	
	--Next, bound weapons
	items = Inspect.Item.Detail(Utility.Item.Slot.Inventory())
	for k, v in pairs(items) do
		if((v["bound"] == true) and (string.find(v["category"], "weapon"))) then
--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberback .. " slot#: " .. slotnumberback)
			if(not(k == Utility.Item.Slot.Inventory(bagnumberback,slotnumberback))) then
			Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberback,slotnumberback)) end
			slotnumberback = slotnumberback - 1
			if(slotnumberback<1) then
				bagnumberback = bagnumberback - 1
				slotnumberback = (Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberback)))["slots"]
			end
		end
	end
	
	--Next, potions
	items = Inspect.Item.Detail(Utility.Item.Slot.Inventory())
	for k, v in pairs(items) do
		if((v["category"]) and string.find(v["category"], "consumable potion")) then
--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberback .. " slot#: " .. slotnumberback)
			if(not(k == Utility.Item.Slot.Inventory(bagnumberback,slotnumberback))) then
			Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberback,slotnumberback)) end
			slotnumberback = slotnumberback - 1
			if(slotnumberback<1) then
				bagnumberback = bagnumberback - 1
				slotnumberback = (Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberback)))["slots"]
			end
		end
	end
	
	--Next, Food (and drink)
	items = Inspect.Item.Detail(Utility.Item.Slot.Inventory())
	for k, v in pairs(items) do
		if((v["category"]) and string.find(v["category"], "consumable food")) then
--			print("moving " .. v["name"] .. " to bag#: " .. bagnumberback .. " slot#: " .. slotnumberback)
			if(not(k == Utility.Item.Slot.Inventory(bagnumberback,slotnumberback))) then
			Command.Item.Move(k,Utility.Item.Slot.Inventory(bagnumberback,slotnumberback)) end
			slotnumberback = slotnumberback - 1
			if(slotnumberback<1) then
				bagnumberback = bagnumberback - 1
				slotnumberback = (Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag",bagnumberback)))["slots"]
			end
		end
	end
end

--Sort both the front loading stuff (sellables, junk, quests, artifacts) and the back loading stuff (gear/usables)
--function sortinventory()
--	sorttrash()
--	sortgear()
--end

--table.insert(Command.Slash.Register("sort-all"), {sortinventory, "NalsBagSort", "sortinventory"})
table.insert(Command.Slash.Register("nmlook"), {lookatitem, "NalsBagSort", "lookatitem"})
table.insert(Command.Slash.Register("sort-trash"), {sorttrash, "NalsBagSort", "sorttrash"})
--table.insert(Command.Slash.Register("sort-gear"), {sortgear, "NalsBagSort", "sortgear"})
--table.insert(Command.Slash.Register("foo"), {printlist, "NalsBagSort", "printinventorylist"})